Files
ports/Tools/scripts/hackage-get-latest-version.sh
T
Tijl Coosemans b6ec06f079 */*: Use C.UTF-8 locale
Ports 02f27a83b4 fixed the ports tree to the C locale so it would work
correctly in environments where users use a locale that isn't compatible
with the C locale, e.g. xx_YY.UTF-8 where [A-Z] includes more than just
upper case letters.  USE_LOCALE was introduced to let ports use another
locale if they needed it.  The C.UTF-8 locale was created later on to be
mostly compatible with the C locale.

Switch the ports tree locale to C.UTF-8 and remove USE_LOCALE.  The
world has moved to Unicode so all ports either require it or know how to
build correctly in a Unicode environment.

PR:		295945
Exp-run by:	antoine
2026-06-30 22:03:57 +02:00

50 lines
1.1 KiB
Bash
Executable File

#!/bin/sh
#
# MAINTAINER: yuri@FreeBSD.org
set -e
set -o pipefail
export LC_ALL=C.UTF-8
##
## hackage-get-latest-version.sh: retrieves the latest version of a given Haskell package as registered on https://hackage.haskell.org
##
# args
PACKAGE_NAME="$1"
if [ -z "$PACKAGE_NAME" ]; then
echo "Usage: $0 <package-name>"
echo "Example: $0 cryptol"
echo "Example: $0 ShellCheck"
exit 1
fi
# check that packaged dependencies are installed
for dep in curl jq version_sort; do
if ! which -s $dep; then
echo "error: the '$dep' dependency is missing"
if [ $dep = "curl" ]; then
echo "... please install the 'curl' package"
elif [ $dep = "jq" ]; then
echo "... please install the 'jq' package"
elif [ $dep = "version_sort" ]; then
echo "... please install the 'libversion' package"
fi
exit 1
fi
done
# MAIN
curl -H "Accept: application/json" https://hackage.haskell.org/package/$PACKAGE_NAME 2>/dev/null |
grep -v "Package not found: No such package in package index" |
jq -r 'keys[]' |
version_sort |
tail -1 ||
! echo "failed to find the Haskell package '$PACKAGE_NAME'"